'// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
'// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
'// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
'// PARTICULAR PURPOSE.
'//
'// Copyright (c) Microsoft Corporation. All rights reserved

#COMPILE EXE "SimpleD2.exe"
#DIM ALL
#INCLUDE ONCE "d2d1.inc"
#INCLUDE ONCE "d2d1Helper.inc"
#INCLUDE ONCE "wincodec.inc"
#INCLUDE ONCE "dwrite.inc"
#INCLUDE ONCE "d2dUtils.inc"

#RESOURCE "SimpleD2.pbr"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

GLOBAL g_pID2D1Helper AS ID2D1Helper
GLOBAL g_pD2DFactory AS ID2D1Factory
GLOBAL g_pPathGeometry AS ID2D1PathGeometry
GLOBAL g_pTextFormat AS IDWriteTextFormat
GLOBAL g_pIWICFactory AS IWICImagingFactory
GLOBAL g_pDWriteFactory AS IDWriteFactory
GLOBAL g_pWICFactory AS IWICImagingFactory
GLOBAL g_pRenderTarget AS ID2D1HwndRenderTarget
GLOBAL g_pBlackBrush AS ID2D1SolidColorBrush
GLOBAL g_pLinearGradientBrush AS ID2D1LinearGradientBrush
GLOBAL g_pGridPatternBitmapBrush AS ID2D1BitmapBrush
GLOBAL g_pBitmap AS ID2D1Bitmap
GLOBAL g_pAnotherBitmap AS ID2D1Bitmap

FUNCTION WinMain (BYVAL hInstance AS DWORD, BYVAL hPrevInstance AS DWORD, BYVAL lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG

    LOCAL hWndMain    AS DWORD
    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WNDCLASSEX
    LOCAL szClassName AS ASCIIZ * 80
    LOCAL rc          AS RECT
    LOCAL szCaption   AS ASCIIZ * 255
    LOCAL hr, IsInitialized AS LONG
    LOCAL x, y, w, h  AS LONG

    ' // Create an instance of the CD2D1Helper class
    g_pID2D1Helper = CLASS "CD2D1Helper"
    IF ISNOTHING(g_pID2D1Helper) THEN
       MsgBox "Unable to create the D2D1Helper class"
       EXIT FUNCTION 
    END IF

    hr = CreateDeviceIndependentResources()
    IF hr = 0 THEN
 
       szClassName = "ZD2D1BITMAP"

       IsInitialized = GetClassInfoEx(hInstance, szClassName, wc)
       IF IsInitialized   = 0 THEN
          wc.cbSize        = SIZEOF(wc)
          wc.style         = %CS_HREDRAW OR %CS_VREDRAW
          wc.lpfnWndProc   = CODEPTR(WndProc)
          wc.cbClsExtra    = 0
          wc.cbWndExtra    = 0
          wc.hInstance     = hInstance
          wc.hIcon         = LoadIcon (%NULL, BYVAL %IDI_APPLICATION)
          wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
          wc.hbrBackground = %NULL ' GetStockObject(%BLACK_BRUSH)
          wc.lpszMenuName  = %NULL
          wc.lpszClassName = VARPTR(szClassName)
          wc.hIconSm       = wc.hIcon
          IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
       END IF

       IF IsInitialized THEN
        ' // Create the application window.
        ' //
        ' // Because the CreateWindow function takes its size in pixels, we
        ' // obtain the system DPI and use it to scale the window size.
          LOCAL dpiX, dpiY AS SINGLE
          g_pD2DFactory.GetDesktopDpi(dpiX, dpiY)

          ' Window caption
          szCaption = "Direct2D Demo App"

          w = CEIL(640 * dpiX / 96)
          h = CEIL(480 * dpiY / 96)
          x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - w) \ 2, 0)
          y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - h) \ 2, 0)

          ' Create a window using the registered class
          hWndMain = CreateWindowEx(%WS_EX_CONTROLPARENT, _    ' extended style
                             szClassName, _                    ' window class name
                             szCaption, _                      ' window caption
                             %WS_OVERLAPPEDWINDOW, _           ' window styles
                             x, _                              ' initial x position
                             y, _                              ' initial y position
                             w, _                              ' initial width
                             h, _                              ' initial height
                             %NULL, _                          ' parent window handle
                             0, _                              ' window menu handle
                             hInstance, _                      ' program instance handle
                             BYVAL %NULL)                      ' creation parameters

          IF hWndMain THEN

           ' Show the main window
             CALL ShowWindow(hWndMain, nCmdShow)
             'CALL SetForegroundWindow(hWndMain)
             CALL Updatewindow(hWndMain)

             WHILE GetMessage(Msg, %NULL, 0, 0)
                 IF IsDialogMessage(hWndMain, Msg) = %FALSE THEN
                    CALL TranslateMessage(msg)                ' Translate The Message
                    CALL DispatchMessage(msg)                 ' Dispatch The Message
                 END IF
             WEND

             FUNCTION = msg.wParam

          END IF
       END IF
    END IF

'   // Cleanup
    g_pID2D1Helper   = NOTHING
    g_pD2DFactory    = NOTHING
    g_pPathGeometry  = NOTHING
    g_pTextFormat    = NOTHING
    g_pIWICFactory   = NOTHING
    g_pDWriteFactory = NOTHING
    g_pWICFactory    = NOTHING
    g_pRenderTarget  = NOTHING
    g_pBlackBrush    = NOTHING
    g_pLinearGradientBrush = NOTHING

    g_pGridPatternBitmapBrush = NOTHING
    g_pBitmap                 = NOTHING
    g_pAnotherBitmap          = NOTHING

END FUNCTION

'// Create resources which are not bound
'// to any device. Their lifetime effectively extends for the
'// duration of the app. These resources include the Direct2D,
'// DirectWrite, and WIC factories; and a DirectWrite Text Format object
'// (used for identifying particular font characteristics) and
'// a Direct2D geometry.
'//
FUNCTION CreateDeviceIndependentResources() AS LONG

    DIM msc_fontName  AS WSTRINGZ * 16
    DIM msc_LocalName AS WSTRINGZ * 16
    LOCAL msc_fontSize AS SINGLE
    
    msc_fontName = "Verdana"
    msc_localName = ""
    msc_fontsize = 50

    LOCAL pSink AS ID2D1GeometrySink
    LOCAL hr AS LONG

    '// Create a Direct2D factory.
    hr = D2D1CreateFactory(%D2D1_FACTORY_TYPE_SINGLE_THREADED, $IID_ID2D1Factory, BYVAL %NULL, g_pD2DFactory)
    IF hr = 0 THEN
       '// Create WIC factory.
       hr = CoCreateInstance( _
            $CLSID_WICImagingFactory, _
            NOTHING, _
            %CLSCTX_INPROC_SERVER, _
            $IID_IWICImagingFactory, _
            g_pWICFactory _
            )
      ' -or-
      ' g_pWICFactory = NEWCOM CLSID $CLSID_WICImagingFactory
    END IF

    IF hr = 0 THEN
        '// Create a DirectWrite factory.
        hr = DWriteCreateFactory( _
            %DWRITE_FACTORY_TYPE_SHARED, _
            $IID_IDWriteFactory, _ '//__uuidof(g_pDWriteFactory), _
            g_pDWriteFactory _
            )
    END IF

    IF hr = 0 THEN
        '// Create a DirectWrite text format object.
        hr = g_pDWriteFactory.CreateTextFormat( _
            msc_fontName, _ 
            NOTHING, _
            %DWRITE_FONT_WEIGHT_NORMAL, _
            %DWRITE_FONT_STYLE_NORMAL, _
            %DWRITE_FONT_STRETCH_NORMAL, _
            msc_fontSize, _
            msc_localName, _
            g_pTextFormat _
            )
    END IF

    IF hr = 0 THEN
        '// Center the text horizontally and vertically.
        g_pTextFormat.SetTextAlignment(%DWRITE_TEXT_ALIGNMENT_CENTER)

        g_pTextFormat.SetParagraphAlignment(%DWRITE_PARAGRAPH_ALIGNMENT_CENTER)

        '// Create a path geometry.
        hr = g_pD2DFactory.CreatePathGeometry(g_pPathGeometry)
    END IF
    IF hr = 0 THEN
        '// Use the geometry sink to write to the path geometry.
        hr = g_pPathGeometry.Open(pSink)
    END IF
    IF hr = 0 THEN
        pSink.SetFillMode(%D2D1_FILL_MODE_ALTERNATE)

        LOCAL currentLocation AS D2D1_POINT_2F
        currentLocation.x = 0
        currentLocation.y = 0   

        pSink.BeginFigure(currentLocation, %D2D1_FIGURE_BEGIN_FILLED)

        currentLocation.x = 200
        currentLocation.y = 0   
        pSink.AddLine(currentLocation)

        pSink.AddBezier( _
            g_pID2D1Helper.BezierSegment( _
                g_pID2D1Helper.Point2F(150, 50), _
                g_pID2D1Helper.Point2F(150, 150), _
                g_pID2D1Helper.Point2F(200, 200)) _
            )

'        pSink.AddLine(g_pID2D1Helper.Point2F(0, 200));
        currentLocation.x = 0
        currentLocation.y = 200   
        pSink.AddLine(currentLocation)

        pSink.AddBezier( _
            g_pID2D1Helper.BezierSegment( _
                g_pID2D1Helper.Point2F(50, 150), _
                g_pID2D1Helper.Point2F(50, 50), _
                g_pID2D1Helper.Point2F(0, 0)) _
            )

        pSink.EndFigure(%D2D1_FIGURE_END_CLOSED)

        hr = pSink.Close()
    END IF

    pSink = NOTHING

    FUNCTION = hr
END FUNCTION

'//  This method creates resources which are bound to a particular
'//  Direct3D device. It's all centralized here, in case the resources
'//  need to be recreated in case of Direct3D device loss (eg. display
'//  change, remoting, removal of video card, etc).
FUNCTION CreateDeviceResources(BYVAL hWnd AS LONG) AS LONG

    LOCAL hr AS LONG

    IF ISNOTHING(g_pRenderTarget) THEN
    
        LOCAL uSize AS D2D1_SIZE_U
        'LOCAL nType AS DWORD, pixelFormat AS D2D1_PIXEL_FORMAT, dpiX, dpiY AS SINGLE, usage, minlevel AS DWORD
        LOCAL dxgiFormat, alphaMode AS DWORD
        LOCAL brushProperties AS D2D1_BRUSH_PROPERTIES

        LOCAL rc AS RECT
        CALL GetClientRect(hWnd, rc)

        uSize = g_pID2D1Helper.SizeU(rc.nRight - rc.nLeft, rc.nBottom - rc.nTop)

        '// Create a Direct2D render target.
        'nType = %D2D1_RENDER_TARGET_TYPE_DEFAULT
        'dxgiFormat = %DXGI_FORMAT_UNKNOWN
        'alphaMode = %D2D1_ALPHA_MODE_UNKNOWN
        'pixelFormat = g_pID2D1Helper.PixelFormat(dxgiFormat, alphaMode)
        'dpiX = 0.0
        'dpiY = 0.0
        'usage = %D2D1_RENDER_TARGET_USAGE_NONE
        'minLevel = %D2D1_FEATURE_LEVEL_DEFAULT
        hr = g_pD2DFactory.CreateHwndRenderTarget( _
             g_pID2D1Helper.RenderTargetProperties(), _     '//nType, pixelFormat, dpiX, dpiY, usage, minLevel), _
             g_pID2D1Helper.HwndRenderTargetProperties(hWnd, uSize, %D2D1_PRESENT_OPTIONS_NONE), _
             g_pRenderTarget)

        IF hr = 0 THEN
           '// Create a black brush.
           brushProperties.opacity = 1.0
           brushProperties.transform =  g_pID2D1Helper.IdentityMatrix()
           hr = g_pRenderTarget.CreateSolidColorBrush( _
                g_pID2D1Helper.ColorF_2(%D2D1_Black, 1.0), _
                brushProperties, _
                g_pBlackBrush)
        END IF

        IF hr = 0 THEN
           LOCAL pGradientStops AS ID2D1GradientStopCollection
           '// Create a linear gradient.
           DIM stops(1) AS D2D1_GRADIENT_STOP
           stops(0).position = 0.0: stops(0).color = g_pID2D1Helper.ColorF(0.0, 1.0, 1.0, 0.25)
           stops(1).position = 1.0: stops(1).color = g_pID2D1Helper.ColorF(0.0, 0.0, 1.0, 1.0)
           hr = g_pRenderTarget.CreateGradientStopCollection( _
                stops(0), _
                2, _
                0, _
                0, _
                pGradientStops _
                )

           IF hr = 0 THEN
              hr = g_pRenderTarget.CreateLinearGradientBrush( _
                    g_pID2D1Helper.LinearGradientBrushProperties(g_pID2D1Helper.Point2F(100, 0), g_pID2D1Helper.Point2F(100, 200)), _
                    g_pID2D1Helper.BrushProperties(1.0, g_pID2D1Helper.IdentityMatrix()), _
                    pGradientStops, _
                    g_pLinearGradientBrush _
                    )
              pGradientStops = NOTHING
           END IF
        END IF

        '// Create a bitmap from an application resource.
        LOCAL sResourceName, sResourceType AS WSTRINGZ * 16
        sResourceName = "SampleImage"
        sResourceType = "Image"
        hr = D2D_LoadBitmapFromResource( _
             g_pRenderTarget, _
             g_pWICFactory, _
             0, _ '// hInstance
             sResourceName, _
             sResourceType, _
             100, _
             0, _
             g_pBitmap _
             )

        IF hr = 0 THEN
           '// Create a bitmap by loading it from a file.
           LOCAL sFileName AS WSTRINGZ * %MAX_PATH
           sFileName = EXE.Path$ + "sampleImage.jpg"
           hr = D2D_LoadBitmapFromFile( _
               g_pRenderTarget, _
               g_pWICFactory, _
               sFileName, _
               100, _
               0, _
               g_pAnotherBitmap _
               )
        END IF
        IF hr = 0 THEN
            hr = CreateGridPatternBrush(g_pRenderTarget, g_pGridPatternBitmapBrush)
        END IF
    END IF

    FUNCTION = hr
END FUNCTION

'// Creates a pattern brush.
FUNCTION CreateGridPatternBrush(pRenderTarget AS ID2D1RenderTarget, ppBitmapBrush AS ID2D1BitmapBrush) AS LONG

    LOCAL hr AS LONG
    LOCAL pCompatibleRenderTarget AS ID2D1BitmapRenderTarget 
    'LOCAL desiredPixelSize AS D2D1_SIZE_U
    'LOCAL desiredFormat AS D2D1_PIXEL_FORMAT

    '// Create a compatible render target.

    hr = pRenderTarget.CreateCompatibleRenderTarget( _
         g_pID2D1Helper.SizeF(10.0, 10.0), _
         BYVAL %NULL, _ 'desiredPixelSize, _
         BYVAL %NULL, _ 'desiredFormat, _
         %D2D1_COMPATIBLE_RENDER_TARGET_OPTIONS_NONE, _
         pCompatibleRenderTarget _
         )

    IF hr = 0 THEN
       '// Draw a pattern.
       LOCAL pGridBrush AS ID2D1SolidColorBrush
       LOCAL brushProperties AS D2D1_BRUSH_PROPERTIES
       brushProperties.opacity = 1.0
       brushProperties.transform =  g_pID2D1Helper.IdentityMatrix()
       hr = pCompatibleRenderTarget.CreateSolidColorBrush( _
            g_pID2D1Helper.ColorF(0.93, 0.94, 0.96, 1.0), _
            brushProperties, _
            pGridBrush _
            )

       IF hr = 0 THEN
          pCompatibleRenderTarget.BeginDraw()
          pCompatibleRenderTarget.FillRectangle(g_pID2D1Helper.RectF(0.0, 0.0, 10.0, 1.0), pGridBrush)
          pCompatibleRenderTarget.FillRectangle(g_pID2D1Helper.RectF(0.0, 0.1, 1.0, 10.0), pGridBrush)
          pCompatibleRenderTarget.EndDraw()

          '// Retrieve the bitmap from the render target.
          LOCAL pGridBitmap AS ID2D1Bitmap
          hr = pCompatibleRenderTarget.GetBitmap(pGridBitmap)
          IF hr = 0 THEN
             '// Choose the tiling mode for the bitmap brush.
             LOCAL bitmapbrushProperties AS D2D1_BITMAP_BRUSH_PROPERTIES
             bitmapbrushProperties = g_pID2D1Helper.BitmapBrushProperties(%D2D1_EXTEND_MODE_WRAP, %D2D1_EXTEND_MODE_WRAP, %D2D1_BITMAP_INTERPOLATION_MODE_LINEAR)

             '// Create the bitmap brush.
             hr = g_pRenderTarget.CreateBitmapBrush(pGridBitmap, bitmapbrushProperties, brushProperties, ppBitmapBrush)

             pGridBitmap = NOTHING
          END IF

          pGridBrush = NOTHING
       END IF

       pCompatibleRenderTarget = NOTHING
    END IF

    FUNCTION = hr
END FUNCTION

'//  Discard device-specific resources which need to be recreated
'//  when a Direct3D device is lost
SUB DiscardDeviceResources()
    g_pRenderTarget = NOTHING
    g_pBitmap = NOTHING
    g_pBlackBrush = NOTHING
    g_pLinearGradientBrush = NOTHING
    g_pAnotherBitmap = NOTHING
    g_pGridPatternBitmapBrush = NOTHING
END SUB


'//  Called whenever the application needs to display the client
'//  window. This method draws a bitmap a couple times, draws some
'//  geometries, and writes "Hello, World"
'//
'//  Note that this function will not render anything if the window
'//  is occluded (e.g. when the screen is locked).
'//  Also, this function will automatically discard device-specific
'//  resources if the Direct3D device disappears during function
'//  invocation, and will recreate the resources the next time it's
'//  invoked.
FUNCTION OnRender(BYVAL hWnd AS LONG) AS LONG

    LOCAL hr AS LONG

    hr = CreateDeviceResources(hWnd)

    IF hr = 0 THEN
       IF (g_pRenderTarget.CheckWindowState() AND %D2D1_WINDOW_STATE_OCCLUDED) = 0 THEN

          LOCAL renderTargetSize, BitmapSize AS D2D1_SIZE_F

          LOCAL sc_helloWorld AS WSTRINGZ * 16
          sc_helloWorld = "Hello, World!"

          '// Retrieve the size of the render target.
          renderTargetSize = g_pRenderTarget.GetSize()

          g_pRenderTarget.BeginDraw()
          
          g_pRenderTarget.SetTransform(g_pID2D1Helper.IdentityMatrix())

          g_pRenderTarget.Clear(g_pID2D1Helper.ColorF_2(%D2D1_White, 1.0))
          
          '// Paint a grid background.
          g_pRenderTarget.FillRectangle( _
              g_pID2D1Helper.RectF(0.0, 0.0, renderTargetSize.width, renderTargetSize.height), _
              g_pGridPatternBitmapBrush _
              )
          
          IF NOT ISNOTHING(g_pBitmap) THEN
             BitmapSize = g_pBitmap.GetSize()
             '// Draw a bitmap in the upper-left corner of the window.
             g_pRenderTarget.DrawBitmap( _
                 g_pBitmap, _
                 g_pID2D1Helper.RectF(0.0, 0.0, BitmapSize.width, BitmapSize.height), _
                 1.0, _ '// opacity
                 %D2D1_BITMAP_INTERPOLATION_MODE_LINEAR)
                 'OPTIONAL BYREF sourceRectangle AS D2D1_RECT_F
                 ') 
          END IF

          '// Draw a bitmap at the lower-right corner of the window.
          BitmapSize = g_pAnotherBitmap.GetSize()
          g_pRenderTarget.DrawBitmap( _
              g_pAnotherBitmap, _
              g_pID2D1Helper.RectF(renderTargetSize.width - BitmapSize.width, renderTargetSize.height - BitmapSize.height, renderTargetSize.width, renderTargetSize.height), _
              1.0, _ '// opacity
              %D2D1_BITMAP_INTERPOLATION_MODE_LINEAR)
              'OPTIONAL BYREF sourceRectangle AS D2D1_RECT_F
              ')
          
          '// Set the world transform to a 45 degree rotation at the center of the render target
          '// and write "Hello, World".
          g_pRenderTarget.SetTransform( _
              g_pID2D1Helper.MatrixRotation( _
                  45, _
                  g_pID2D1Helper.Point2F( _
                      renderTargetSize.width / 2, _
                      renderTargetSize.height / 2)) _
              )
          
          g_pRenderTarget.DrawText( _
              sc_helloWorld, _
              LEN(sc_helloWorld), _
              g_pTextFormat, _
              g_pID2D1Helper.RectF(0, 0, renderTargetSize.width, renderTargetSize.height), _
              g_pBlackBrush, _
              %D2D1_DRAW_TEXT_OPTIONS_NONE, _
              %DWRITE_MEASURING_MODE_NATURAL _
              )
          
          '// Reset back to the identity transform
          g_pRenderTarget.SetTransform( _
              g_pID2D1Helper.MatrixTranslation(0, renderTargetSize.height - 200) _
              )
          
          '// Fill the hour glass geometry with a gradient.
          g_pRenderTarget.FillGeometry(g_pPathGeometry, g_pLinearGradientBrush)
          
          g_pRenderTarget.SetTransform( _
              g_pID2D1Helper.MatrixTranslation(renderTargetSize.width - 200, 0) _
              )
          
          '// Fill the hour glass geometry with a gradient.
          g_pRenderTarget.FillGeometry(g_pPathGeometry, g_pLinearGradientBrush)
          
          hr = g_pRenderTarget.EndDraw()
          
          IF hr = %D2DERR_RECREATE_TARGET THEN
             hr = 0
             DiscardDeviceResources()
          END IF

       END IF
    END IF

    FUNCTION = hr
END FUNCTION


'//  If the application receives a WM_SIZE message, this method
'//  resize the render target appropriately.
SUB OnResize(BYVAL nWidth AS LONG, BYVAL nHeight AS LONG)
    IF NOT ISNOTHING(g_pRenderTarget) THEN
       LOCAL su AS D2D1_SIZE_U

       su.width = nWidth
       su.height = nHeight
       '// Note: This method can fail, but it's okay to ignore the
       '// error here -- it will be repeated on the next call to
       '// EndDraw.
       g_pRenderTarget.Resize(su)
    END IF
END SUB

'// The window message handler.
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

    LOCAL ps AS PAINTSTRUCT

    SELECT CASE LONG Msg

    CASE %WM_SIZE
         OnResize(LO(INTEGER, lParam), HI(INTEGER, lParam))

    CASE %WM_PAINT, %WM_DISPLAYCHANGE
         CALL BeginPaint(hWnd, ps)
         CALL OnRender(hWnd)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY
         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

